CREATE OR REPLACE FUNCTION CLASSIFICA_PRODUTOS_DACON(
   P_IDTIPODADOS   IN CHAR,
   P_CDPRODUTO     IN PRODUTO.CDPRODUTO%TYPE,
   P_CDLIVROMAG    IN RELACPRODITGEN.CDLIVROMAG%TYPE,
   P_CDNATUBC      IN VARCHAR,
   P_CSTNFE        IN VARCHAR) RETURN VARCHAR

AS
   V_IDTIPOPRODUTO CHAR;
/*BUSCA OS PRODUTOS DE ACORDO COM A CLASSIFICAO DA TIPI */

/*P_IDTIPODADOS I = TIPO DE INSUMO (RETORNA A = INSUMO DE ORIGEM ANIMAL - RETORNA V = INSUMO DE ORIGEM ANIMAL)*/

/*P_IDTIPODADOS R - TIPO DE RECEITA DO BEM (RETORNTA B = RECEITA DE BENS E SERVIOS, O = OUTROS) */

BEGIN

   FOR C_PRODUTOS IN(SELECT P.CDPRODUTO, REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(P.CDCLASFISC,'.'),'/'),' '),','),'-') AS CDCLASFISC,
                            R.CDTPITEMPROD, R.CDGENPROD
                       FROM PRODUTO P, RELACPRODITGEN R
                       WHERE P.CDNVPRODUTO = (SELECT MAX(PP.CDNVPRODUTO) FROM PRODUTO PP)
                         AND P.CDPRODUTO   = P_CDPRODUTO
                         AND R.CDPRODUTO   = P.CDPRODUTO
                         AND R.CDLIVROMAG  = P_CDLIVROMAG)LOOP

      V_IDTIPOPRODUTO:= NULL;

      IF P_IDTIPODADOS = 'I' AND P_CDNATUBC = '01' AND P_CSTNFE BETWEEN '60' AND '67' THEN
        /*------------------------/*INSUMOS DE ORIGEM ANIMAL------------------------------------------------------------*/

         /*CAPTULO 2 exceto os cdigos 02.01, 02.02, 02.03,0206.10.00, 0206.20, 0206.21, 0206.29, 0206.30.00, 0206.4, 02.07, 0210.1*/
         IF (SUBSTR(C_PRODUTOS.CDCLASFISC,1,2) = '02') THEN
            IF SUBSTR(C_PRODUTOS.CDCLASFISC,1,4) NOT IN ('0201', '0202', '0203','0207') AND SUBSTR(C_PRODUTOS.CDCLASFISC,1,5) NOT IN ('02064' ,'02101') THEN
               IF SUBSTR(C_PRODUTOS.CDCLASFISC,1,6) NOT IN ('020620','020621','020629','020604') THEN
                  IF SUBSTR(C_PRODUTOS.CDCLASFISC,1,8) NOT IN  ('02061000', '02063000') THEN
                     V_IDTIPOPRODUTO:= 'A';
                  END IF;
               END IF;
            END IF;
         END IF;

         /*3(exceto os produtos vivos desse captulo), 4, 8  15 (exceto o cdigo 1502.00.1), 16 */
         IF SUBSTR(C_PRODUTOS.CDCLASFISC,1,2) IN ('03','04','16') OR SUBSTR(C_PRODUTOS.CDCLASFISC,1,4) BETWEEN '1501' AND '1506' OR
            SUBSTR(C_PRODUTOS.CDCLASFISC,1,6) = ('151610') OR SUBSTR(C_PRODUTOS.CDCLASFISC,1,4) IN ('1517','1518') THEN

            IF SUBSTR(C_PRODUTOS.CDCLASFISC,1,7) <> '1502001' AND SUBSTR(C_PRODUTOS.CDCLASFISC,1,4) <> '1507' THEN
               V_IDTIPOPRODUTO:= 'A';
            END IF;

         END IF;

         /*e nos cdigos 0504.00, 0701.90.00, 0702.00.00, 0706.10.00, 07.08, 0709.90, 07.10, 07.12 a 07.14 (exceto os cdigos 0713.33.19, 0713.33.29 e 0713.33.99)*/
         /*IF SUBSTR(C_PRODUTOS.CDCLASFISC,1,6) IN ('050400','070990') OR SUBSTR(C_PRODUTOS.CDCLASFISC,1,4) IN ('0708','0710') OR
            SUBSTR(C_PRODUTOS.CDCLASFISC,1,8) IN ('07019000','07020000', '07061000') OR SUBSTR(C_PRODUTOS.CDCLASFISC,1,4) BETWEEN '0712' AND '0714' THEN

            IF SUBSTR(C_PRODUTOS.CDCLASFISC,1,8) NOT IN ('07133319', '07133329' ,'07133399') THEN
               V_IDTIPOPRODUTO:= 'A';
            END IF;

         END IF;*/

         /*IF SUBSTR(C_PRODUTOS.CDCLASFISC,1,8) IN ('17011100','17019900','17029000','18040000','18050000','21011110','22090000') OR
            SUBSTR(C_PRODUTOS.CDCLASFISC,1,4) IN ('1801', '1803','2009') THEN
            V_IDTIPOPRODUTO:= 'A';
         END IF;*/

         /*nos cdigos 07.08, 07.10, 18.01, 18.03, 20.09, 07.12 a 07.14, exceto os cdigos 0713.33.19, 0713.33.29 e 0713.33.99 da TIPI*/
         /*IF SUBSTR(C_PRODUTOS.CDCLASFISC,1,4) IN ('0708','0710','0712','0713','0714','1801', '1803', '2009') THEN
            IF SUBSTR(C_PRODUTOS.CDCLASFISC,1,8) NOT IN ('07133319','07133329','07133399') THEN
               V_IDTIPOPRODUTO:= 'A';
            END IF;
         END IF;*/


         /*---------------------------------INSUMOS DE ORIGEM VEGETAL-------------------------------------------------------*/
         IF SUBSTR(C_PRODUTOS.CDCLASFISC,1,4) IN ('1201','1507',' 2304') OR SUBSTR(C_PRODUTOS.CDCLASFISC,1,8) = '12081000' THEN
            V_IDTIPOPRODUTO:= 'V';
         END IF;

         IF SUBSTR(C_PRODUTOS.CDCLASFISC,1,5) = '2204' THEN
            V_IDTIPOPRODUTO:= 'V';
         END IF;

         /*CASO NO CAIA NOS ITENS CITADOS*/
         IF V_IDTIPOPRODUTO IS NULL THEN
            IF SUBSTR(C_PRODUTOS.CDCLASFISC,1,2) IN ('02','03','04','05') THEN
               V_IDTIPOPRODUTO:= 'A';
            END IF;

            IF SUBSTR(C_PRODUTOS.CDCLASFISC,1,2) IN ('06','07','08','09','10','11','12','13','14') THEN
               V_IDTIPOPRODUTO:= 'V';
            END IF;

         END IF;

      END IF;

      /*TIPO DE RECEITA*/
      IF P_IDTIPODADOS = 'R' THEN

         IF C_PRODUTOS.CDTPITEMPROD IN ('00','04','09') THEN
            V_IDTIPOPRODUTO:= 'B';
         ELSE
            V_IDTIPOPRODUTO:= 'O';
         END IF;

      END IF;

   END LOOP;
   RETURN(V_IDTIPOPRODUTO);

END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CLASSIFICA_PRODUTOS_DACON','5.60.000'); END;
/
