function Dfs88000_Conhecimento_de_transporte_eletronico_Controller(ScreenService, templateManager, ZhFilterPreferences, General, MessageService, Dfs88000_Conhecimento_de_transporte_eletronico_Service) {
    
    //Nome das fields. Estilo: IDCAD + name[0], name[1] + NMRAZSOCCLIE, name[1] + NMRAZSOCFORN e NMRAZSOZ + name[2]. Exemplo: IDCADREMETENTE, REMETNMRAZSOCCLIE, REMETNMRAZSOCFORN e NMRAZSOCREME
    var fieldNames = [["REMETENTE", "REMET", "REME"], ["EXPEDIDOR", "EXP", "EXPE"], ["RECEBEDOR", "RECEB", "RECE"], ["DESTINATA", "DEST", "DEST"], ["TOMADOR", "TOMAD", "TOMA"]];
        
    
    this.widgetOnEnter = function (widget) {
        this.setDefaultFilterCTE(widget);
        let fieldStatus = widget.getField('IDSTATUSCTE');
        fieldStatus.setValue(fieldStatus.defaultValue);
    };
    
    this.setDefaultFilterCTE = function(widget) {
        var currentRow = widget.currentRow;
        var row        = { CDFILIAL: getLocalVar('CDFILIAL')};
        
        General.callRestEngine("df_saida#/defaultFilterCTE", "Row", row).then((defaultFilter) =>  {
            defaultFilter = defaultFilter.dataset.defaultFilter;
            var keys = ['DTEMISSAODEFAULT'];
            var filter = Util.clone(currentRow, ["__rightActions", "__leftActions"]);
            keys.map((key) => {
                if(key == 'DTEMISSAODEFAULT') {
                    filter.DTEMISSAO = {
                        start:  defaultFilter[key],
                        period: undefined,
                        end:    defaultFilter[key]
                    };
                }
                filter[key] = defaultFilter[key];
            });
            ZhFilterPreferences.setOriginalFilter(widget.id, filter);
            ZhFilterPreferences.openFilterWidget(widget, filter).then ( () => {
                var filterWidget = templateManager.container.getActiveWidget();
                filterWidget.actions.filter(action => action.name === "clear")[0].shortcutKey = "ctrl+backspace";
                filterWidget.getField('NRINSESTEMIT').readOnly = !filterWidget.currentRow.CDEMPRESA;
                filterWidget.getField("NRINSESTEMIT").dataSourceFilter[0].value = filterWidget.currentRow.CDEMPRESA;
                //Inicializa os campos "Status", Remetente", "Expedidor", "Recebedor", "Destinatário" e "Tomador" com a opção "Todos"
                for (let fieldName of ['IDSTATUSCTE', 'IDCADREMETENTE', 'IDCADEXPEDIDOR', 'IDCADRECEBEDOR', 'IDCADDESTINATA', 'IDCADTOMADOR']) {
                    filterWidget.getField(fieldName).setValue('');
                }
                filterWidget.getField('IDCADREMETENTE').setValue('');
            });
        },
        (error) => {
            ZhFilterPreferences.openFilterWidget(widget).then ( () => {
                var filterWidget = templateManager.container.getActiveWidget();
                filterWidget.actions.filter(action => action.name === "clear")[0].shortcutKey = "ctrl+backspace";
            });
        });
    };
    
    this.newDataSourceBeforeApply = function(args) {
        args.e.preventDefault();
        let row = args.e.preference.FILTER_ROW;
        let widget = args.owner;
        
        widget.dataSourceFilter = Dfs88000_Conhecimento_de_transporte_eletronico_Service.buildFilter(row);
        
        widget.reload().then ( () => {
            ScreenService.closePopup(); 
        });
        General.callRestEngine("df_saida#/getDefaultCte", "Row", row).then((success) => {
            Dfs88000_Conhecimento_de_transporte_eletronico_Service.setDefaultCte(success.dataset.cte);
        });
    };
    
    this.validacoesAfterMoveRow = function (widget) {
        this.setDataCampoInscricao(widget);
        this.controlaStatusWidgets(widget, widget.name, true);
    };
    
    this.empresaOnChange = function(widget) {
        let activeWidget = templateManager.container.getActiveWidget();
        
        if (activeWidget.name == 'zhFilterPreferencesSelectConditions')
            activeWidget.getField("NRINSESTEMIT").dataSourceFilter[0].value = activeWidget.currentRow.CDEMPRESA;
        
        widget.currentRow.CDINSCESTA = '';
        widget.currentRow.NRINSESTEMIT = '';
        if(!widget.currentRow.CDEMPRESA)   widget.getField('NRINSESTEMIT').readOnly = true;
        else widget.getField('NRINSESTEMIT').readOnly = false;
        
        this.limpaDadosEndereco(widget, "EMIT");
        
        widget.getField('NRINSESTEMIT').reload();
    };
    
    this.paisEstadoOnChange = function(fieldChanged) {
        var fieldPais, fieldEstado, fieldMunicipio;
        var widget = fieldChanged.widget;
        if (['NMPAISINISERV','NMESTADOINISERV'].includes(fieldChanged.name)) {
            fieldPais      =   widget.getField('NMPAISINISERV');
            fieldEstado    = widget.getField('NMESTADOINISERV');
            fieldMunicipio =  widget.getField('NMMUNICINISERV');
        }
        else if (['NMPAISFIMSERV','NMESTADOFIMSERV'].includes(fieldChanged.name)) {
            fieldPais      =   widget.getField('NMPAISFIMSERV');
            fieldEstado    = widget.getField('NMESTADOFIMSERV');
            fieldMunicipio =  widget.getField('NMMUNICFIMSERV');
        }
        else {
            return;
        }
        
        if (fieldChanged == fieldPais) {
            fieldEstado.setValue('');
            fieldEstado.reload();
            fieldMunicipio.readOnly = true;
        }
        fieldMunicipio.setValue('');
        fieldMunicipio.reload();
        
        var pais      =      fieldPais.value();
        var estado    =    fieldEstado.value();
        var municipio = fieldMunicipio.value();
        
        if (!pais) {
            fieldEstado.setValue('');
            fieldEstado.readOnly = true;
            fieldMunicipio.setValue('');
            fieldMunicipio.readOnly = true;
        }
        else {
            fieldEstado.readOnly = false;
            fieldMunicipio.readOnly = false;
        }
        if (!estado) {
            fieldMunicipio.setValue('');
            fieldMunicipio.readOnly = true;
        }
        else {
            fieldMunicipio.readOnly = false;
        }
    };
    
    this.retiradaOnChange = function(field) {
        var widget = field.widget;
        var fieldDetalhes = widget.getField('DSRETIRA');

        if (field.value() == field.valueToTrue) {
            fieldDetalhes.readOnly = false;
        }
        else {
            fieldDetalhes.readOnly = true;
            fieldDetalhes.setValue('');
        }
    };
    
    this.tipoInscricaoOnChange = function(widget) {
        this.alteraVisibilidadeCampoInscricao(widget, true);
    };
    
    this.limpaDadosEndereco = function (widget, typeName) {
        //Limpa os dados de endereço, telefone e e-mail.
        //typeName: nome dos tipos de campo. Ex: EMIT, REME, RECE
        for (let baseName of ['NRTELE', 'DSEMAIL', 'DSENDE', 'DSCOMPEND', 'NRCEP', 'NMPAIS', 'NMESTADO', 'NMMUNICIPIO', 'NMBAIR', 'CDPAIS', 'SGESTADO', 'CDMUNICIPIO']) {
            let fieldName = baseName + typeName;
            widget.currentRow[fieldName] = '';
        }
    };
    
    this.setDataCampoInscricao = function (widget) {
        let fieldNrinsestemit = widget.getField('NRINSESTEMIT');
        if (fieldNrinsestemit) {
            fieldNrinsestemit.setValue(widget.currentRow.NRINSESTEMIT);
            fieldNrinsestemit.reload();
        }
        
        for (let tipo of fieldNames) {
            let nameFieldTipo = "IDCAD" + tipo[0];
            let namefieldCliente = tipo[1] + "NMRAZSOCCLIE";
            let namefieldFornecedor = tipo[1] + "NMRAZSOCFORN";
            let nameRazSocField = "NMRAZSOC" + tipo[2];
            
            let fieldCliente = widget.getField(namefieldCliente);
            let fieldFornecedor = widget.getField(namefieldFornecedor);
            let razSoc = widget.currentRow[nameRazSocField];
            
            if (!fieldCliente || !fieldFornecedor) {
                continue;
            }
            
            switch (widget.currentRow[nameFieldTipo]) {
                case "C":
                    fieldCliente.setValue(razSoc);
                    break;
                case "F":
                    fieldFornecedor.setValue(razSoc);
                    break;
                default:
            }
            
        }
    };
    
    this.setFieldGroupVisibleStatus = function(fieldgroups, name, status){
	    var fieldgroup = fieldgroups.find(function(fieldgroup){
            return fieldgroup.name === name;
        });

        fieldgroup.isVisible = status;
	};
    
    this.alteraVisibilidadeCampoInscricao = function(widget, limpaValues = true) {
        if (widget.name == "main_cte") {
            return;
        }

        for (let tipo of fieldNames) {
            let nameFieldTipo = "IDCAD" + tipo[0];
            let namefieldCliente = tipo[1] + "NMRAZSOCCLIE";
            let namefieldFornecedor = tipo[1] + "NMRAZSOCFORN";
            
            let fieldCliente = widget.getField(namefieldCliente);
            let fieldFornecedor = widget.getField(namefieldFornecedor);
            
            if (!fieldCliente || !fieldFornecedor) {
                continue;
            }
            
            switch (widget.currentRow[nameFieldTipo]) {
                case "C":
                    this.validacaoCamposOutTipoFilter(fieldCliente, fieldFornecedor);
                    if (limpaValues) {
                        widget.currentRow[namefieldFornecedor] = null;
                        this.limpaDadosEndereco(widget, tipo[2]);
                    }
                    break;
                case "F":
                    this.validacaoCamposOutTipoFilter(fieldFornecedor, fieldCliente);
                    if (limpaValues) {
                        widget.currentRow[namefieldCliente] = null;
                        this.limpaDadosEndereco(widget, tipo[2]);
                    }
                    break;
                default:
                    this.validacaoCamposOutTipoFilter(fieldCliente, fieldFornecedor);
                    fieldCliente.readOnly = true;
                    delete fieldCliente.validations;
                    if (limpaValues) {
                        widget.currentRow[namefieldCliente] = null;
                        widget.currentRow[namefieldFornecedor] = null;
                        this.limpaDadosEndereco(widget, tipo[2]);
                    }
            }
        }
        
        widget.reload();
    };
    
    this.novoCte = function (widget) {
        widget.newRow();
        let currentRow = widget.currentRow;   
        Dfs88000_Conhecimento_de_transporte_eletronico_Service.getDefaultCte().then((defaultCte) => {
            this.controlaStatusWidgets(widget, widget.name, false);
            currentRow = Object.assign(currentRow, defaultCte[0]);
            currentRow.__is_new = true;
            
            widget.getField("NMFANTEMIT").reload();
            widget.getField("NRINSESTEMIT").reload();
            
            this.paisEstadoOnChange(widget.getField("NMPAISINISERV"));
            this.paisEstadoOnChange(widget.getField("NMPAISFIMSERV"));
            
            widget.getField("DSRETIRA").readOnly = true;
        });
    };
    
    this.salvarCte = function (widget) {
        var widgetCte = widget.name == 'main_cte' ? widget : widget.getParent();
        var currentRow = widget.currentRow;
        
        if (!widget.isValid()) {
            return;
        }
        
        //Ao criar um novo CT-e, alterar para a aba seguinte antes de salvar no banco. (Repetir até a aba de Tomador)
        if (currentRow.__is_new && widget.name != 'tomador_cte') {
            let nextWidget;
            
            if (widget.name == 'main_cte') {
                nextWidget = widget.widgets.filter( widget => widget.name == 'emitente_cte')[0];
            }
            else {
                let currentIndex;
                widget.getParent().widgets.forEach( (wdg, index) => {
                    if (wdg.name == widget.name) {
                        currentIndex = index;
                    }
                });
                nextWidget = widget.getParent().widgets[currentIndex+1];
            }
            widget.view();
            this.controlaStatusWidgets(widgetCte, nextWidget.name, false);
            nextWidget.enabled = true;
            nextWidget.activate();
            nextWidget.edit();
            return;
        }
        
        General.callRestEngine("df_saida#/salvarCte", "Row", currentRow).then (response => {
            let newRow = response.messages[0].message;
            if (newRow) {
                Object.assign(currentRow, newRow);
            }
            if (widget.name === 'totais_cte') {
                this.totaisChangeVisibility(widget, true);
                widget.widgets.forEach(widgetFilha => {
                    widgetFilha.actions.filter(action => action.name == "salvarTotais")[0].isVisible = false;
                    widgetFilha.actions.filter(action => action.name == "cancelar")[0].isVisible = false;
                    widgetFilha.actions.filter(action => action.name == "salvar")[0].isVisible = true;
                });

            }
            widget.view(); 
            widgetCte.view();
            widget.reload();
            this.controlaStatusWidgets(widgetCte, widget.name, true);
            this.setDataCampoInscricao(widget);
        }).catch(error => {
            ScreenService.showMessage(error.error);
        });
    };
    
    this.widgetCteOnEdit = function(widgetCte) {
        this.controlaStatusWidgets(widgetCte, 'main_cte', false);
        General.edit(widgetCte);
        
        //Define campos de País, Estado e Município para poderem ser alterados.
        let fieldPaisInicio = widgetCte.getField('NMPAISINISERV');
        let fieldEstadoInicio = widgetCte.getField('NMESTADOINISERV');
        let fieldMunicipioInicio = widgetCte.getField('NMMUNICINISERV');
        
        let fieldPaisFim = widgetCte.getField('NMPAISFIMSERV');
        let fieldEstadoFim = widgetCte.getField('NMESTADOFIMSERV');
        let fieldMunicipioFim = widgetCte.getField('NMMUNICFIMSERV');
        
        fieldPaisInicio.readOnly = false;
        fieldEstadoInicio.readOnly = false;
        fieldMunicipioInicio.readOnly = false;
        
        fieldPaisFim.readOnly = false;
        fieldEstadoFim.readOnly = false;
        fieldMunicipioFim.readOnly = false;
    };
    
    this.widgetFilhaOnEnter = function(widget) {
        widget.currentRow = widget.getParent().currentRow;
        this.setDataCampoInscricao(widget);
        this.alteraVisibilidadeCampoInscricao(widget, false);
        widget.redraw();
    };
    
    this.widgetFilhaOnEdit = function(widget) {
        var widgetCte = widget.getParent();
        this.controlaStatusWidgets(widgetCte, widget.name, false);
        this.setDataCampoInscricao(widget);
        General.edit(widget);
    };
    
    this.widgetFilhaOnCancel = function(widget) {
        var widgetCte = widget.getParent();
        var currentRow = widget.currentRow;
        
        //Se a row é nova, retorna para a grip principal, pois ela ainda não foi salva no banco.
        if (currentRow.__is_new) {
            ScreenService.closeSwipe();
            widget.getParent().dataSource.data.pop();
        }
        else {
            widget.view();
            //Retorna a row para seu valor antes da edição
            for (var i in widget.backupRow) {
				widget.currentRow[i] = widget.backupRow[i];
			}
        }
        this.controlaStatusWidgets(widgetCte, widget.name, true);
    };
    
    this.dadosAdicOnEnter = function (widget) {
        widget.reload();
    };
    
    this.dadosAdicOnCancel = function(widget) {
        var widgetCte = widget.getParent();
        
        widget.list();
        widget.reload();
        this.controlaStatusWidgets(widgetCte, widget.name, true);
    };
    
    this.dadosAdicOnSave = function (widget) {
        var currentRow = widget.currentRow;
        
        if (!widget.isValid()) return;
        
        //Se a row é nova, define valores de CDCTEDADOSADIC e CDCTE
        if (currentRow.__is_new) {
            //Busca maior CDCTEDADOSADIC já existente
            let maxCDCTEDADOSADIC = 0;
            widget.dataSource.data.forEach(row => {
                if (row.CDCTEDADOSADIC > maxCDCTEDADOSADIC) {
                    maxCDCTEDADOSADIC = row.CDCTEDADOSADIC;
                }
            });
            maxCDCTEDADOSADIC++;
            
            currentRow.CDCTEDADOSADIC = maxCDCTEDADOSADIC;
            currentRow.CDCTE = widget.getParent().currentRow.CDCTE;
        }
        
        widget.saveRow().then (() => {
            widget.list();
            widget.reload();
        }).catch(error => {
            ScreenService.showMessage(error.error);
        });
        
    };
    
    this.dadosAdicOnDelete = function (widget) {
        MessageService.confirmMessageByCode("REGISTRO_EXCLUIR").then (() => {
            widget.removeRow().then (() => {
                widget.list();
                widget.reload();
            });   
        });
    };
    
    this.totaisChangeValidations = function (widget) {
        var row = widget.currentRow;
        if(row.VRTOTAPRESTSERV != null)
            delete widget.getField('VRTOTAPRESTSERV').validations.required;
        else 
            widget.getField('VRTOTAPRESTSERV').validations.required = true;
       
        if(row.DSOUTCARCARGA != null)
            delete widget.getField('DSOUTCARCARGA').validations.required;
        else
            widget.getField('DSOUTCARCARGA').validations.required = true;
            
        if(row.VRTOTARECEBER != null)
            delete widget.getField('VRTOTARECEBER').validations.required;   
        else 
            widget.getField('VRTOTARECEBER').validations.required = true;
            
    };
    
    this.totaisOnEnter = function (widget) {
        this.totaisOnCancel(widget);
        this.widgetFilhaOnEnter(widget);
        this.totaisChangeValidations(widget);
        widget.reload();
    };
    
    //Coloca o widget Totais "manualmente" no modo de edição.
    //Isso é necessário pois o widget é do estilo tabbedWidget
    this.totaisOnEdit = function (widget) {
        var widgetCte = widget.getParent();
        this.controlaStatusWidgets(widgetCte, widget.name, false);
        
        widget.backupRow = Util.clone(widget.currentRow);
        
        this.totaisChangeVisibility(widget, true);
        
        widget.widgets.forEach(widgetFilha => {
            widgetFilha.actions.filter(action => action.name == "salvarTotais")[0].isVisible = true;
            widgetFilha.actions.filter(action => action.name == "cancelar")[0].isVisible = true;
            widgetFilha.actions.filter(action => action.name == "salvar")[0].isVisible = false;
        });
            
        widget.edit();
    };
    
    //Coloca o widget Totais "manualmente" no modo de exibição.
    //Isso é necessário pois o widget é do estilo tabbedWidget
    this.totaisOnCancel = function (widget) {
        var widgetCte = widget.getParent();
        this.controlaStatusWidgets(widgetCte, widget.name, true);
        
        if (widget.backupRow && (widget.currentRow.CDCTE == widget.backupRow.CDCTE)) {
            //Retorna a row para seu valor antes da edição
            for (var i in widget.backupRow) {
    			widget.currentRow[i] = widget.backupRow[i];
    		}  
        }
        
        this.totaisChangeVisibility(widget, false);
        this.totaisChangeValidations(widget);
        this.widgetFilhaOnEnter(widget);
        widget.reload();
    };
    
    
    this.totaisOnSave = function (widget) {
        widget.saveRow().then (() => {
            widget.list();
            this.totaisChangeValidations(widget);
            widget.reload();
            this.salvarCte(widget);
        }).catch(error => {
            ScreenService.showMessage(error.error);
        });
    };
    //Altera a visibilidade das ações e readOnly dos campos da widget Totais.
    //Parâmetro edicao: Indica se a widget deve ir para o modo de edição
    this.totaisChangeVisibility = function (widget, edicao ) {
        
        if(edicao) {
            widget.fields.forEach(field => {
                field.readOnly = false;
            });
            
            //Altera a visibilidade das ações das widget filhas
            widget.widgets.forEach(widgetFilha => {
                widgetFilha.actions.forEach(action => {
                    switch (action.name) {
                        case 'editar':
                        case 'voltar': action.isVisible = false; break;
                        
                        case 'salvar':
                        case 'cancelar': action.isVisible = true; break;
                        
                        default:
                    }
                });
            });
        } else {
            //Seta ReadOnly dos campos
            widget.fields.forEach(field => {
                field.readOnly = true;
            });
            //Altera a visibilidade das ações das widget filhas
            widget.widgets.forEach(widgetFilha => {
                widgetFilha.actions.forEach(action => {
                    switch (action.name) {
                        case 'editar':
                        case 'voltar': action.isVisible = true; break;
                        
                        case 'salvar':
                        case 'cancelar': action.isVisible = false; break;
                        
                        default:
                    }
                });
            });
        }
        
    };
    
    this.adicionarCmpValorCte = function (widgetTotais) {
        var widget = templateManager.container.getActiveWidget();
        widget.newRow();
        widget.reload();
        this.controlaStatusWidgets(widget, widget.name, true, widgetTotais);

    };
    
    this.widgetCteOnCancel = function (args) {
        var widget = args.owner.widget;
        General.backOrCancel(args);    
        this.controlaStatusWidgets(widget, widget.name, true);
    };
    
   /** 
    * Funções Gerais
    */
    
    this.validacaoCamposOutTipoFilter = function(principalField) {
        principalField.showOnView = true;
        principalField.showOnForm = true;
        principalField.isVisible = true;
        principalField.readOnly = false;
        principalField.readOnlyOnEdit = false;
        principalField.validations = {"required": true};

        for (var i = 1; i < arguments.length; i++) {
            arguments[i].showOnView = false;
            arguments[i].showOnForm = false;
            arguments[i].isVisible = false;
            arguments[i].readOnly = true;
            delete arguments[i].validations;
        }
    };
    
    this.controlaStatusWidgets = function(widgetPai, nomeWidgetAtual, status, ignoredWidgets) {
        var allWidgets = widgetPai.widgets;

        allWidgets.filter(widget => widget.name !== nomeWidgetAtual).forEach(widget => widget.enabled = status);

        if (widgetPai.name !== nomeWidgetAtual)
            widgetPai.enabled = status;

        if (Array.isArray(ignoredWidgets))
            allWidgets.filter(widget => ignoredWidgets.indexOf(widget.name) !== -1).forEach(widget => widget.enabled = !status);
    };
    
}

Configuration(function (ContextRegister) {
    ContextRegister.register("Dfs88000_Conhecimento_de_transporte_eletronico_Controller", Dfs88000_Conhecimento_de_transporte_eletronico_Controller);
});
